import maya.cmds as cmds
from random import uniform, choice

def add_string_attr(attrname, text):
	# we take care of using the special prefix
	attrname = 'rmanS' + attrname
	
	# selections will be either a number of shapes (possibly only one shape),
	# or one or more groups that contains shapes.
	shapes = []
	selections = cmds.ls(sl=True)
	for sel in selections:
		shapes = cmds.listRelatives(sel, shapes=True)
		# sel is a group...
		if shapes == None:
			transforms = cmds.listRelatives(sel, children=True)
			shapes = []
			for tran in transforms:
				shapes.extend(cmds.listRelatives(tran, shapes=True))		
		if len(shapes) == 0 or len(shapes[0]) == 0:
			print('Cannot find a shape to add attribute')
			continue
		for shape in shapes:
			if cmds.attributeQuery(attrname, node=shape, exists=True) == False:
				cmds.addAttr(shape, ln=attrname, sn=attrname, nn=attrname, dt="string")
			#path = choice(paths)
			cmds.setAttr(shape + '.' + attrname, text, type="string")
#==============================================================================
