#!/usr/bin/env python

# 1  Copy this script to the images folder and then run it.
#    It will create a file called,
#		run_denoise.bat (Windows)
#    or
#		run_denoise (OSX and Linux) 
# 2  Double click the run_denoise script and it will open a
#    terminal that will show the progress of the denoising.
# Malcolm Kesson
# March 9 2017

import os
import sys
import glob

path = __file__
command = 'denoise  --crossframe -v variance -f default.filter.json '
rootpath = os.path.dirname(path)
pattern = os.path.join(rootpath, "*.exr");

image_paths = glob.glob(pattern)
if len(image_paths) > 0:
	image_paths.sort()
	proj_dir_name = os.path.dirname(image_paths[0])
	image_name = os.path.basename(image_paths[0])
	
	offset = image_name.find('.')
	if offset > 0:
		bracketed_extensions = ''
		image_name = image_name[0:offset]
		run_path = os.path.join(rootpath, 'run_denoise')
		if os.name == "nt":
			run_path += '.bat'
		f = open(run_path , 'w')
		f.write('%s %s.' % (command, os.path.join(proj_dir_name, image_name)))
		for path in image_paths:
			image_name = os.path.basename(path)
			if image_name.find('_filtered') == -1:
				num_ext = image_name[offset + 1:]
				last_dot = num_ext.find('.')
			#	print('num_ext = %s  last_dot = %s' % (num_ext,last_dot))
				if last_dot > 0:
					num_ext = num_ext[0:last_dot]
					bracketed_extensions += num_ext + ','
		if len(bracketed_extensions) > 1:
			bracketed_extensions = bracketed_extensions[:-1]
			f.write('{%s}.exr ' % (bracketed_extensions))
		f.close()
